/***************************************************************************
 *   Copyright (C) 2007 by Ларин Анатолий   *
 *   _junk@mail.ru   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "WGl.h"
#include <math.h>
#include <qimage.h>
#include <GL/glu.h>

int oldx=0,oldy=0;

void WGL::loadTexture(){
  QImage  tex1,buf;
  if(!buf.load(textureName)) qerror->message("Can't load texture: "+textureName);
  else
  {
    tex1 = convertToGLFormat(buf);
    //tex1 = tex1.scale(256, 256);
    //gluScaleImage(GL_RGBA, tex1.width(), tex1.height(), GL_UNSIGNED_BYTE, tex1.bits(), 
    gluBuild2DMipmaps(GL_TEXTURE_2D, 4, tex1.width(), tex1.height(), GL_RGBA, GL_UNSIGNED_BYTE, tex1.bits());
  }
}

void drawXpart(){

 // glPushMatrix();
  glBegin(GL_QUADS);

  // Передняя грань
  glNormal3f( 0.0f, 0.0f, 1.0f);
  glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);	// Низ лево
  glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);	// Низ право
  glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f,  1.0f);	// Верх право
  glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f,  1.0f);	// Верх лево

  // Задняя грань
  glNormal3f( 0.0f, 0.0f,-1.0f);
  glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f, -1.0f);	// Низ право
  glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);	// Верх право
  glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);	// Верх лево
  glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f, -1.0f);	// Низ лево

  // Верхняя грань
  glNormal3f( 0.0f, 1.0f, 0.0f);
  glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);	// Верх лево
  glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f,  1.0f,  1.0f);	// Низ лево
  glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f,  1.0f,  1.0f);	// Низ право
  glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);	// Верх право
	
  // Нижняя грань
  glNormal3f( 0.0f,-1.0f, 0.0f); 
  glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f, -1.0f, -1.0f);	// Верх право
  glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f, -1.0f, -1.0f);	// Верх лево
  glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);	// Низ лево
  glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);	// Низ право

  // Правая грань
  glNormal3f( 1.0f, 0.0f, 0.0f); 
  glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f, -1.0f);	// Низ право
  glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);	// Верх право
  glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f,  1.0f,  1.0f);	// Верх лево
  glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);	// Низ лево

  // Левая грань
  glNormal3f(-1.0f, 0.0f, 0.0f);
  glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f, -1.0f);	// Низ лево
  glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);	// Низ право
  glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f,  1.0f,  1.0f);	// Верх право
  glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);	// Верх лево

  glEnd();
  ///glPopMatrix();
}

void WGL::paintGL(){
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

//Отрисовка модели
  glPushMatrix();
  //glRotated(25,0,0,1);  
  glTranslated(0,0.5,0);
  glScalef(1.0,0.1,0.1);
  drawXpart();
  glPopMatrix();

  glPushMatrix();
  //glRotated(25,0,0,-1);  
  glTranslated(0,-0.5,0);
  glScalef(1.0,0.1,0.1);
  drawXpart();
  glPopMatrix();

  glPushMatrix();
  glRotated(90,0,0,-1);  
  glTranslated(0,-0.5,0);
  glScalef(1.0,0.1,0.099);
  drawXpart();
  glPopMatrix();

  glPushMatrix();
  glRotated(90,0,0,-1);  
  glTranslated(0,0.5,0);
  glScalef(1.0,0.1,0.099);
  drawXpart();
  glPopMatrix();

}

void WGL::setDefault(){
  //Установка стандартных значений
  
  prPerspective = true;

  bgColor.setRgb(0,0,0);

  bgLight.setRgb(0.9*255,0.9*255,0.9*255);
  bLighting = true;
  bLight0 = true;

  diffuseLight.setRgb(255,255,255);
  ambientLight.setRgb(0.2*255,0.2*255,0);
  textureName = "textures/wood.jpg";

  posX=2;
  posY=2;
  posZ=2;
  posW=2;

  spotX=1;
  spotY=1;
  spotZ=1;
  spotW=0.7;
}

void WGL::setLight()
{
 //Источник света
  if(bLighting) glEnable(GL_LIGHTING); else glDisable(GL_LIGHTING);
  if(bLight0) glEnable(GL_LIGHT0); else glDisable(GL_LIGHT0);
  
  //Общая освещенность
  GLfloat afTmp[4] = {bgLight.red()/255., bgLight.green()/255., bgLight.blue()/255., 1};
  glLightModelfv(GL_LIGHT_MODEL_AMBIENT, afTmp);


  afTmp[0] = posX;
  afTmp[1] = posY;
  afTmp[2] = posZ;
  afTmp[2] = posW;
  glLightfv(GL_LIGHT0, GL_POSITION, afTmp);

  afTmp[0] = spotX;
  afTmp[1] = spotY;
  afTmp[2] = spotZ;
  afTmp[3] = spotW;
  glLightfv(GL_LIGHT0, GL_SPOT_DIRECTION, afTmp);


}

void WGL::setMaterial()
{
//Свойства материала модели

  GLfloat afTmp[4];

  afTmp[0] = diffuseLight.red()/255.;
  afTmp[1] = diffuseLight.green()/255.;
  afTmp[2] = diffuseLight.blue()/255.;
  afTmp[3] = 1.;
  glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, afTmp);

  afTmp[0] = ambientLight.red()/255.;
  afTmp[1] = ambientLight.green()/255.;
  afTmp[2] = ambientLight.blue()/255.;
  afTmp[3] = 1.;
  glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, afTmp);
}

void WGL::setClearColor()
{
  glClearColor(bgColor.red()/255.,bgColor.green()/255.,bgColor.blue()/255.,1.0);
}

void WGL::initializeGL()
{
  setDefault();
  glClearDepth(1.0);
//  startTimer(100);

  loadTexture();

  glEnable(GL_RESCALE_NORMAL);
  glEnable(GL_NORMALIZE);
  glEnable(GL_POLYGON_SMOOTH);
  glEnable(GL_TEXTURE_2D);
  glEnable(GL_DEPTH_TEST);
  glDepthFunc(GL_LESS);

  setLight();
  setMaterial();
}

void WGL::setProjection()
{
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  GLdouble awidth = width(), aheight=height();

  if(prPerspective)
  {
    gluPerspective(10.0f,(GLfloat) awidth/(GLfloat)aheight,1.f,100.0f);
    gluLookAt(6, 8, 10, 0, 0, 0, 0, 0, 1);
  }
  else 
    glOrtho(0,0,1,1,-1,1);
  
  glMatrixMode(GL_MODELVIEW);
}

void WGL::resizeGL( int width, int height )
{ 

  glViewport(0,0,width,height);
  setProjection();
}

int Angle=0,VAngle=0;

void WGL::mouseMoveEvent ( QMouseEvent * e )
{
  GLdouble dx = 0, dy = 0;
  dy = (GLdouble) (e->y()-oldy);
  dx = (GLdouble) (e->x()-oldx);
  oldy= e->y();
  oldx= e->x();

  if((dy!=(GLdouble)oldy)&&(dx!=(GLdouble)oldx))
  {
    glMatrixMode(GL_PROJECTION);
    glRotated(dx*0.5, 0, 1., 0);
    glRotated(dy*0.5, 1., 0, 0);
    glMatrixMode(GL_MODELVIEW);  
    updateGL();
  }
}

void WGL::mouseReleaseEvent ( QMouseEvent * e )
{
  oldx = 0;
  oldy = 0;
}

void WGL::mouseDoubleClickEvent ( QMouseEvent * e )
{
  doubleClick();
}

void WGL::wheelEvent ( QWheelEvent * e )
{
  GLdouble dscale=0;
  dscale = (1+(GLdouble) e->delta()/120.*0.1);
  glMatrixMode(GL_PROJECTION);
  glScaled(dscale, dscale, dscale);
  glMatrixMode(GL_MODELVIEW);  
  updateGL();
}



void WGL::keyPressEvent(QKeyEvent* e)
{
  switch(e->key())
  {
   case Key_Plus:
    glMatrixMode(GL_PROJECTION);
    glScalef(1.2,1.2,1.2);
    glMatrixMode(GL_MODELVIEW);  
    break;

   case Key_Minus:
    glMatrixMode(GL_PROJECTION);
    glScalef(5.0/6.0,5.0/6.0,5.0/6.0);
    glMatrixMode(GL_MODELVIEW);  
    break;

   case Key_Up:
    glMatrixMode(GL_PROJECTION);
    glRotated(-2.0,1.0,0.0,0.0);
    if(VAngle>=360)
     VAngle=0;
    VAngle+=2;
    glMatrixMode(GL_MODELVIEW);
    break;

   case Key_Down:
    glMatrixMode(GL_PROJECTION);
    glRotated(2.0,1.0,0.0,0.0);
    if(VAngle>=360)
     VAngle=0;
    VAngle+=2;
    glMatrixMode(GL_MODELVIEW);
    break;

   case Key_Left:
    glMatrixMode(GL_PROJECTION);
    glRotated(-2.0,0.0,1.0,0.0);
    if(Angle>=360)
     Angle=0;
    Angle+=2;
    glMatrixMode(GL_MODELVIEW);
    break;

   case Key_Right:
    glMatrixMode(GL_PROJECTION);
    glRotated(2.0,0.0,1.0,0.0);
    if(Angle<=0)
     Angle=360;
    Angle-=2;
    glMatrixMode(GL_MODELVIEW);
    break;
  }

  updateGL();
}

void WGL::timerEvent(QTimerEvent* e)
{
  /*glMatrixMode(GL_PROJECTION);
  glRotated(-1.0,0.0,1.0,0.0);
  if(Angle>=360)
  Angle=0;
  Angle+=5;
  glMatrixMode(GL_MODELVIEW);
  updateGL();*/
}
