/***************************************************************************
 *   Copyright (C) 2007 by Ларин Анатолий   *
 *   _junk@mail.ru   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef WGL_H
#define WGL_H

#include <qgl.h>
#include <qerrormessage.h>
//#include "guiwidget.h"

class WGL:public QGLWidget
{
  Q_OBJECT

  protected:
   virtual void paintGL();
   void initializeGL();
   void resizeGL( int width, int height );
  public:
   QErrorMessage* qerror;
  // GuiWidget* guiWidget;
   void keyPressEvent(QKeyEvent*);
   void mouseMoveEvent ( QMouseEvent * e );
   void mouseReleaseEvent ( QMouseEvent * e );
   void mouseDoubleClickEvent ( QMouseEvent * e );
   void wheelEvent ( QWheelEvent * e );
   void timerEvent(QTimerEvent*);
   void loadTexture();

   void setLight();
   void setMaterial();
   void setClearColor();
   void setDefault();
   void setProjection();
   bool prPerspective, bLighting, bLight0;
   QColor bgColor, bgLight, diffuseLight, ambientLight;
   QString textureName;
   float posX, posY, posZ, posW, spotX, spotY, spotZ, spotW;

  signals:
    void doubleClick();
    
};

#endif
