/***************************************************************************
 *   Copyright (C) 2007 by Ларин Анатолий   *
 *   _junk@mail.ru   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "guiwidget.h"
#include "qpushbutton.h"
#include "qcolordialog.h"
#include "qfiledialog.h"
#include "qlineedit.h"
#include "qcheckbox.h"
#include "qlineedit.h"

guiwidget::guiwidget(QWidget* parent, const char* name, bool modal, WFlags fl)
: fGui(parent,name, modal,fl)
{
}

guiwidget::~guiwidget()
{
}

/*$SPECIALIZATION$*/
void guiwidget::pushButton1_clicked()
{
  QColor qc = QColorDialog::getColor();
  pbBg->setPaletteBackgroundColor(qc);
  wgl->bgColor = qc;
  wgl->setClearColor();
  wgl->updateGL();
}

void guiwidget::radioButton1_clicked()
{
  wgl->prPerspective = false;
  wgl->setProjection();
  wgl->updateGL();
}

void guiwidget::radioButton1_2_clicked()
{
  wgl->prPerspective = true;
  wgl->setProjection();
  wgl->updateGL();
}

void guiwidget::pbTextChoose_clicked()
{
  wgl->textureName = QFileDialog::getOpenFileName();
  leTexture->setText(wgl->textureName);
  wgl->loadTexture();
  wgl->updateGL();
}

void guiwidget::pbAmbient_clicked()
{
  QColor qc = QColorDialog::getColor();
  pbAmbient->setPaletteBackgroundColor(qc);
  wgl->ambientLight = qc;
  wgl->setMaterial();
  wgl->updateGL();
}

void guiwidget::pbDiffuse_clicked()
{
  QColor qc = QColorDialog::getColor();
  pbDiffuse->setPaletteBackgroundColor(qc);
  wgl->diffuseLight = qc;
  wgl->setMaterial();
  wgl->updateGL();
}

void guiwidget::cbLight0_clicked()
{
  wgl->bLight0 = cbLight0->isChecked();
  wgl->setLight();
  wgl->updateGL();
}

void guiwidget::cbLighting_clicked()
{
  wgl->bLighting = cbLighting->isChecked();
  wgl->setLight();
  wgl->updateGL();
}

void guiwidget::pbBgLight_clicked()
{
  QColor qc = QColorDialog::getColor();
  pbBgLight->setPaletteBackgroundColor(qc);
  wgl->bgLight = qc;
  wgl->setLight();
  wgl->updateGL();

}

void guiwidget::lePosX_textChanged(const QString&)
{
  wgl->posX = lePosX->text().toFloat();
  wgl->setLight();
  wgl->updateGL();
}

void guiwidget::lePoxY_textChanged(const QString&)
{
  wgl->posY = lePosY->text().toFloat();
  wgl->setLight();
  wgl->updateGL();
}

void guiwidget::lePosZ_textChanged(const QString&)
{
  wgl->posZ = lePosZ->text().toFloat();
  wgl->setLight();
  wgl->updateGL();
}

void guiwidget::lePosW_textChanged(const QString&)
{
  wgl->posW = lePosW->text().toFloat();
  wgl->setLight();
  wgl->updateGL();
}

void guiwidget::leSpotX_textChanged(const QString&)
{
  wgl->spotX = leSpotX->text().toFloat();
  wgl->setLight();
  wgl->updateGL();
}

void guiwidget::leSpotY_textChanged(const QString&)
{
  wgl->spotY = leSpotY->text().toFloat();
  wgl->setLight();
  wgl->updateGL();
}

void guiwidget::leSpotZ_textChanged(const QString&)
{
  wgl->spotZ = leSpotZ->text().toFloat();
  wgl->setLight();
  wgl->updateGL();
}

void guiwidget::leSpotW_textChanged(const QString&)
{
  wgl->spotW = leSpotW->text().toFloat();
  wgl->setLight();
  wgl->updateGL();
}



















